let rgbzLocalStoreModel = function(){
    this.items= {};
    this.origItems= {};
};

let getrgbzLocalStoreNode = ()=>{
    let foundItem = localStorage.getItem("rgbzLocalStoreModel");

    if (!foundItem) {
        foundItem = new rgbzLocalStoreModel();
    }
    else {
        foundItem = parseObjString(foundItem);
    }

    return foundItem;
};

let getJsonString = (store)=>{
    let result = typeof(store) + '╨';

    switch(typeof(store)) {
        case 'object':
            result += (JSON.stringify(store));
            break;
        default:
            result += (store.toString());
            break;
    }

    return result;
};

let storeItem = (key, item)=>{
    let store = getrgbzLocalStoreNode();

    store.items[key] = item;

    if (typeof(store.origItems[key])=== 'undefined' || !store.origItems[key]) {
        store.origItems[key] = item;
    }

    localStorage.setItem("rgbzLocalStoreModel", getJsonString(store));
};

let parseObjString = (item)=>{
    let result = undefined;

    if (item) {
        let itemComponents = item.split('╨');

        if (itemComponents.length>=2) {
            switch(itemComponents[0]) {
                case 'boolean':
                    result = (itemComponents[1]==='true');
                    break;
                case 'number':
                    result = Number(itemComponents[1]);
                    break;
                case 'object':
                    result = JSON.parse(itemComponents[1]);
                    break;
                default:
                    result = itemComponents[1];
                    break;
            }
        }
        else if (itemComponents.length==1) {
            result = itemComponents[0].toString();
        }
    }

    return result;
};

let getItem = (key)=>{
    let store = getrgbzLocalStoreNode();

    let item = store.items[key];

    return item;
};

let clearStore = ()=>{
    localStorage.removeItem("rgbzLocalStoreModel");
};

let resetKeyFromBak = (key)=>{
    let result = undefined;

    let store = getrgbzLocalStoreNode();

    if (typeof(store.origItems[key])!== 'undefined' && store.origItems[key] && typeof(store.items[key])!== 'undefined' && store.items[key]) {
        store.items[key] = store.origItems[key];

        result = store.items[key];
    }

    localStorage.setItem("rgbzLocalStoreModel", getJsonString(store));

    return result;
};

let removeItem = (key)=>{
    let store = getrgbzLocalStoreNode();

    delete store.items[key];
    delete store.origItems[key];

    localStorage.setItem("rgbzLocalStoreModel", getJsonString(store));
};
